<template>
	<div class="admin-progress-component">
		<h2>Progress Status</h2>
		<table>
			<thead>
				<tr>
					<th @click="sort('user')">User Name</th>
					<th @click="sort('experiment')">Experiment</th>
					<th @click="sort('step')">Step</th>
					<th @click="sort('startStepTime')">Step Time</th>
					<th @click="sort('startTime')">Start Time</th>
					<th @click="sort('endTime')">End Time</th>
					<th @click="sort('status')">Status</th>
				</tr>
			</thead>
			<tbody>
				<tr
					v-for="status in displayedProgresses"
					:key="status.user">
					<td>{{ status.user }}</td>
					<td>{{ status.experiment }}</td>
					<td>{{ status.step }}</td>
					<td>{{ formatStepTime(status.startStepTime) }}</td>
					<td>{{ formatDate(status.startTime) }}</td>
					<td>{{ status.endTime ? formatDate(status.endTime) : "N/A" }}</td>
					<td>{{ status.status }}</td>
				</tr>
			</tbody>
		</table>
		<div>
			<div>
				Show
				<select
					v-model="itemsPerPage"
					@change="changeItemsPerPage">
					<option
						v-for="option in options"
						:key="option">
						{{ option }}
					</option>
				</select>
				items per page
			</div>
			Page {{ currentPage }} / {{ totalPages() }}
			<button
				:disabled="currentPage === 1"
				@click="prevPage">
				Previous
			</button>
			<button
				:disabled="currentPage === totalPages()"
				@click="nextPage">
				Next
			</button>
		</div>
	</div>
	<hr />
	<div class="statistics">
		<div>Number of students: {{ progresses.length }}</div>
		<div>Top {{ lastStudent }} students by time spent on current step:</div>
		<ol>
			<li
				v-for="user in topUsersByStepTime()"
				:key="user.user">
				{{ user.user }} -
				{{ formatStepTime(user.startStepTime) }}
			</li>
		</ol>
	</div>
	<div>
		Show
		<select v-model="lastStudent">
			<option
				v-for="option in options"
				:key="option">
				{{ option }}
			</option>
		</select>
		students
	</div>
	<hr />
</template>

<script lang="ts">
	import { defineComponent } from "vue"
	import type { ProgressStatus } from "#/progress"
	import { useExperimentStore } from "@/stores/useExperimentStore"

	interface Data {
		progresses: ProgressStatus[]
		currentPage: number
		itemsPerPage: number
		lastStudent: number
		displayedProgresses: ProgressStatus[]
		options: number[]
		sortKey: keyof ProgressStatus
		sortDesc: "asc" | "desc"
	}

	export default defineComponent({
		name: "AdminRoleComponent",
		data(): Data {
			return {
				progresses: [],
				currentPage: 1,
				itemsPerPage: 5,
				lastStudent: 2,
				displayedProgresses: [],
				options: [2, 5, 10, 20, 50],
				sortKey: "experiment",
				sortDesc: "asc",
			}
		},
		methods: {
			formatDate(date: Date) {
				return new Date(date).toLocaleString("utc", { hour: "numeric", minute: "numeric", second: "numeric" })
			},
			formatStepTime(startStepTime: Date | null) {
				if (!startStepTime) {
					return "N/A"
				}
				const diffMs = new Date().getTime() - startStepTime.getTime()
				const diffMins = Math.floor(diffMs / 60000)
				const diffSecs = Math.round((diffMs % 60000) / 1000)
				return `${diffMins} min ${diffSecs} s`
			},
			totalPages(): number {
				return Math.ceil(this.progresses.length / this.itemsPerPage)
			},
			prevPage() {
				this.currentPage--
				this.updateDisplayedProgresses()
			},
			nextPage() {
				this.currentPage++
				this.updateDisplayedProgresses()
			},
			updateDisplayedProgresses() {
				const startIndex = (this.currentPage - 1) * this.itemsPerPage
				const endIndex = this.currentPage * this.itemsPerPage
				this.displayedProgresses = this.progresses.slice(startIndex, endIndex)
			},
			finishedCount(): number {
				return this.progresses.filter(status => status.status === "success").length
			},
			topUsersByStepTime(): ProgressStatus[] {
				const sortedByTime = this.progresses
					.filter(status => status.startStepTime !== null)
					.sort((a, b) => {
						const timeA = a.startStepTime!.getTime()
						const timeB = b.startStepTime!.getTime()
						return timeB - timeA
					})
				return sortedByTime.slice(0, this.lastStudent)
			},
			changeItemsPerPage() {
				this.currentPage = 1
				this.updateDisplayedProgresses()
			},
			sort(key: keyof ProgressStatus) {
				this.sortKey = key
				this.sortDesc = this.sortDesc === "asc" ? "desc" : "asc"
				// TODO: sort by key
				this.updateDisplayedProgresses()
			},
		},
		async mounted() {
			await useExperimentStore().loadProgressStatus()
			this.progresses = useExperimentStore().progressStatus
			this.updateDisplayedProgresses()
			setInterval(() => {
				useExperimentStore().loadProgressStatus()
				this.progresses = useExperimentStore().progressStatus
			}, 10000)
		},
	})
</script>

<style lang="scss" scoped>
	table {
		border-collapse: collapse;
		width: 100%;
		margin: 20px 0;
	}

	th,
	td {
		text-align: left;
		padding: 8px;
		border-bottom: 1px solid #ddd;
	}

	th {
		background-color: #f2f2f2;
		color: #555;
		font-weight: bold;
	}

	tr:hover {
		background-color: #f5f5f5;
	}

	.success {
		color: green;
	}

	.pending {
		color: orange;
	}

	hr {
		margin: 20px 0;
	}
</style>
